#include <conio.h>
#include "../../Include/define.h"
#include "../../Include/PCI3009.h"
#include "../../Utils/Utils.h"

/* Analog output. */

int main(int argc, char *argv[])
{
    INT   i_ReturnValue = 0;
    BYTE  b_OpenOk = 0;
    BYTE  b_Channel = 0;
    WORD  w_AnalogOutputValue = 0;
    DWORD dw_BoardHandle = 0;

    printf("\nSet 1 voltage analog output.");
    printf("\nPress any key to start\n");
    _getch();

    /* Open the ADDI-DATA driver */
	i_ReturnValue = i_Utils_OpenBoard(&dw_BoardHandle);
    if (i_ReturnValue != 0)
    {
        getch ();
        return;
    }

    if (i_ReturnValue == 0)
    {
        printf("\nSelect the analog output channel (0 - 3): ");
        do
        {
			scanf("%u", &b_Channel);
        }
        while (!((b_Channel >= 0) && (b_Channel <= 3)));

        printf("\nSelect the voltage to set: ");
        printf("\n0 for -10V");
        printf("\n2048 for 0V");
        printf("\n4095 for 10V\n");
        do
        {
			scanf("%hu", &w_AnalogOutputValue);
        }
        while (!((w_AnalogOutputValue >= 0) && (w_AnalogOutputValue <= 4095)));

        i_ReturnValue = i_PCI3009_AnalogOutputWrite1Channel(dw_BoardHandle, b_Channel, w_AnalogOutputValue);

        switch (i_ReturnValue)
        {
            case 0: printf("\ni_AnalogOutputWrite1Channel OK");
                break;

            case -1: printf("\ni_AnalogOutputWrite1Channel: The handle parameter of the board is wrong");
                break;

            case -2: printf("\ni_AnalogOutputWrite1Channel: The channel number parameter is wrong");
                break;

            case -3: printf("\ni_AnalogOutputWrite1Channel: The channel value parameter is wrong");
                break;

            default: printf("\ni_AnalogOutputWrite1Channel: Error = %d", i_ReturnValue);
                break;
        }
    }

    if (b_OpenOk == 1)
    {
        i_ReturnValue = i_PCI3009_CloseBoard(dw_BoardHandle);

        switch (i_ReturnValue)
        {
            case 0: printf("\ni_CloseBoard OK");
                break;

            case -1: printf("\ni_CloseBoard: The handle parameter of the board is wrong");
                break;

            default: printf("\ni_CloseBoard: Error = %d", i_ReturnValue);
                break;
        }
    }

    printf("\nPress any key\n");
    _getch();
}
