#include <conio.h>
#include "../../Include/define.h"
#include "../../Include/PCI3009.h"
#include "../../Utils/Utils.h"

/* Analog output. */

int main(int argc, char *argv[])
{
    INT   i_ReturnValue = 0;
    BYTE  b_OpenOk = 0;
    BYTE  b_Channel = 0;
    BYTE  pb_ChannelList[4];
    WORD  pw_AnalogOutputValueList[4];
    DWORD dw_BoardHandle;

    printf("\nSet more voltage analog output.");
    printf("\nPress any key to start\n");
    _getch();

    /* Open the ADDI-DATA driver */
	i_ReturnValue = i_Utils_OpenBoard(&dw_BoardHandle);
    if (i_ReturnValue != 0)
    {
        getch ();
        return;
    }

    if (i_ReturnValue == 0)
    {
        for (b_Channel = 0; b_Channel < 4; b_Channel++)
        {
            printf("\n\nSelect the voltage to set on channel %d: ", b_Channel);
            printf("\n0 for -10V");
            printf("\n2048 for 0V");
            printf("\n4095 for 10V\n");
            do
            {
                scanf("%hu", &pw_AnalogOutputValueList[b_Channel]);
            }
            while (!((pw_AnalogOutputValueList[b_Channel] >= 0) && (pw_AnalogOutputValueList[b_Channel] <= 4095)));

            pb_ChannelList[b_Channel] = b_Channel;
        }

        i_ReturnValue = i_PCI3009_AnalogOutputWriteMoreChannels(dw_BoardHandle, 4, pb_ChannelList, pw_AnalogOutputValueList);

        switch (i_ReturnValue)
        {
            case 0: printf("\ni_AnalogOutputWriteMoreChannels OK");
                break;

            case -1: printf("\ni_AnalogOutputWriteMoreChannels: The handle parameter of the board is wrong");
                break;

            case -2: printf("\ni_AnalogOutputWriteMoreChannels: Wrong channels number selection");
                break;

            case -3: printf("\ni_AnalogOutputWriteMoreChannels: The channel index 0 number parameter is wrong");
                break;

            case -4: printf("\ni_AnalogOutputWriteMoreChannels: The channel index 0 value parameter is wrong");
                break;

            case -5: printf("\ni_AnalogOutputWriteMoreChannels: The channel index 1 number parameter is wrong");
                break;

            case -6: printf("\ni_AnalogOutputWriteMoreChannels: The channel index 1 value parameter is wrong");
                break;

            case -7: printf("\ni_AnalogOutputWriteMoreChannels: The channel index 2 number parameter is wrong");
                break;

            case -8: printf("\ni_AnalogOutputWriteMoreChannels: The channel index 2 value parameter is wrong");
                break;

            case -9: printf("\ni_AnalogOutputWriteMoreChannels: The channel index 3 number parameter is wrong");
                break;

            case -10: printf("\ni_AnalogOutputWriteMoreChannels: The channel index 3 value parameter is wrong");
                break;

            default: printf("\ni_AnalogOutputWriteMoreChannels: Error = %d", i_ReturnValue);
                break;
        }
    }

    if (b_OpenOk == 1)
    {
        i_ReturnValue = i_PCI3009_CloseBoard(dw_BoardHandle);

        switch (i_ReturnValue)
        {
            case 0: printf("\ni_CloseBoard OK");
                break;

            case -1: printf("\ni_CloseBoard: The handle parameter of the board is wrong");
                break;

            default: printf("\ni_CloseBoard: Error = %d", i_ReturnValue);
                break;
        }
    }

    printf("\nPress any key\n");
    _getch();
}
