/** @file PCI3009.h
 *
 *  @authors S. Beuque, C. Guinot, J. Krauth, N. Reibel, J. Rose, L. Sartory, S. Weber
 *  @date    Creation: 18.09.2013
 *  @date    $LastChangedDate$
 *  @version $LastChangedRevision$
 *
 *  @par DESCRIPTION
 *  Main xPCI3009 header file 
 *
 *  @par LICENCE
 *  @verbatim
 *  Copyright (C) 2009 - 2013 ADDI-DATA GmbH
 *
 *  ADDI-DATA GmbH
 *  Airpark Business Center
 *  Airport Boulevard B210
 *  77836 Rheinmnster
 *  Germany
 *  Tel: +49(0)7229/1847-0    |  Fax: +49(0)7229/1847-200
 *  http://www.addi-data-com  |  info@addi-data.com
 *  @endverbatim
 **/

#ifndef PCI3009_INCREMENTAL_COUNTER
    #define PCI3009_INCREMENTAL_COUNTER                  0x53430000UL
    #define PCI3009_SSI_COUNTER                          0x53490000UL
    #define PCI3009_DIGITAL_IO                           0x44490000UL
    #define PCI3009_CHRONOMETER                          0x43480000UL
    #define PCI3009_DISABLE                              0
    #define PCI3009_ENABLE                               1
    #define PCI3009_SYNCHRONOUS_MODE                     1
    #define PCI3009_ASYNCHRONOUS_MODE                    0

    #define PCI3009_16BIT_COUNTER                        0x10
    #define PCI3009_32BIT_COUNTER                        0x0
    #define PCI3009_QUADRUPLE_MODE                       0x0
    #define PCI3009_DOUBLE_MODE                          0x3
    #define PCI3009_SIMPLE_MODE                          0xF
    #define PCI3009_DIRECT_MODE                          0x80
    #define PCI3009_HYSTERESIS_ON                        0x60
    #define PCI3009_HYSTERESIS_OFF                       0x0
    #define PCI3009_INCREMENT                            0x60
    #define PCI3009_DECREMENT                            0x0
    #define PCI3009_LATCH_COUNTER                        0x1
    #define PCI3009_CLEAR_COUNTER                        0x0
    #define PCI3009_LOW                                  0x0
    #define PCI3009_HIGH                                 0x1
    #define PCI3009_HIGH_EDGE_CLEAR_COUNTER              0x0
    #define PCI3009_HIGH_EDGE_LATCH_COUNTER              0x1
    #define PCI3009_LOW_EDGE_CLEAR_COUNTER               0x2
    #define PCI3009_LOW_EDGE_LATCH_COUNTER               0x3
    #define PCI3009_HIGH_EDGE_LATCH_AND_CLEAR_COUNTER    0x4
    #define PCI3009_LOW_EDGE_LATCH_AND_CLEAR_COUNTER     0x5
    #define PCI3009_SOURCE_0                             0x0
    #define PCI3009_SOURCE_1                             0x1

    #define PCI3009_BINARY_MODE                          0x1
    #define PCI3009_GRAY_MODE                            0x0

    #define PCI3009_SINGLE                               0
    #define PCI3009_DIFF                                 1
    #define PCI3009_CONTINUOUS                           1

    #define PCI3009_1_GAIN                               0
    #define PCI3009_2_GAIN                               1
    #define PCI3009_5_GAIN                               2
    #define PCI3009_10_GAIN                              3
    #define PCI3009_BIPOLAR                              0
    #define PCI3009_UNIPOLAR                             1

    #define PCI3009_MICRO_SECOND                         1
    #define PCI3009_MILLI_SECOND                         2
    #define PCI3009_SECOND                               3

    #define PCI3009_DELAY_MODE_1                         1
    #define PCI3009_DELAY_MODE_2                         2

    #define PCI3009_ONE_SHOT_TRIGGER                     0x1
    #define PCI3009_TRIGGER_START_A_SERIES               0x11

    #define PCI3009_LOW_FRONT                            0x4
    #define PCI3009_HIGH_FRONT                           0x2
    #define PCI3009_LOW_HIGH_FRONT                       0x6

    #define PCI3009_TIMER                                0x4010
    #define PCI3009_UP_COUNTER                           0xE0000
    #define PCI3009_DOWN_COUNTER                         0xA0000
    #define PCI3009_WATCHDOG                             0x0

    #define PCI3009_SET_LOW                              0x1000
    #define PCI3009_SET_HIGH                             0x800
    #define PCI3009_FLIP_FLOP                            0x2800
#endif
