using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using PCI3009_NET;

/* Autorefresh on channel 0, 1, 2, 3 and compare logic 3. */

namespace CompareLogic
{
    class Program
    {
        static void Main(string[] args)
        {
            int i_ReturnValue = 0;
            byte b_OpenOk = 0;
            byte b_NbrOfChannels = 4;
            byte b_Channel = 0;
            int w_ChannelMask = 0;
            byte b_Stop = 0;
            String ReadString;
            int w_ConvertTime = 100;
            PCI3009_NET.cl_PCI3009.cl_AutoRefreshDataPackage s_AutoRefreshDataPackage = new PCI3009_NET.cl_PCI3009.cl_AutoRefreshDataPackage();            
            cl_PCI3009 PCI3009 = new cl_PCI3009();

            Console.Write("\nCompare logic sample");

            if (!Utils.Utils.openBoard(PCI3009))
            {
                Console.ReadKey();
                return;
            }

            if (i_ReturnValue == 0)
            {
                i_ReturnValue = PCI3009.i_AnalogInputInitMode(PCI3009_NET.cl_PCI3009.PCI3009_SINGLE);

                switch (i_ReturnValue)
                {
                    case 0: Console.Write("\ni_AnalogInputInitMode OK");
                        break;

                    case -1: Console.Write("\ni_AnalogInputInitMode: The handle parameter of the board is wrong");
                        break;

                    case -2: Console.Write("\ni_AnalogInputInitMode: Wrong single/diff mode");
                        break;

                    case -3: Console.Write("\ni_AnalogInputInitMode: A conversion is already started");
                        break;

                    default: Console.Write("\ni_AnalogInputInitChannel: Error = {0}", i_ReturnValue);
                        break;
                }
            }

            if (i_ReturnValue == 0)
            {
                for (b_Channel = 0; b_Channel < b_NbrOfChannels; b_Channel++)
                {
                    i_ReturnValue = PCI3009.i_AnalogInputInitChannel(b_Channel, PCI3009_NET.cl_PCI3009.PCI3009_1_GAIN, PCI3009_NET.cl_PCI3009.PCI3009_UNIPOLAR);

                    switch (i_ReturnValue)
                    {
                        case 0: Console.Write("\ni_AnalogInputInitChannel OK");
                            break;

                        case -1: Console.Write("\ni_AnalogInputInitChannel: The handle parameter of the board is wrong");
                            break;

                        case -2: Console.Write("\ni_AnalogInputInitChannel: Wrong channel number");
                            break;

                        case -3: Console.Write("\ni_AnalogInputInitChannel: Wrong gain");
                            break;

                        case -4: Console.Write("\ni_AnalogInputInitChannel: Wrong polarity");
                            break;

                        case -5: Console.Write("\ni_AnalogInputInitChannel: A conversion is already started");
                            break;

                        default: Console.Write("\ni_AnalogInputInitChannel: Error = {0}", i_ReturnValue);
                            break;
                    }
                }
            }

            if (i_ReturnValue == 0)
            {
                for (b_Channel = 0; b_Channel < b_NbrOfChannels; b_Channel++)
                {
                    /* Initialize the compare logic "Compare logic analog value < compare value enabled" */
                    i_ReturnValue = PCI3009.i_AnalogInputInitCompareLogic(b_Channel, 3, 10.0, 3, 12.0);

                    switch (i_ReturnValue)
                    {
                        case 0: Console.Write("\ni_AnalogInputInitCompareLogic OK");
                            break;

                        case -1: Console.Write("\ni_AnalogInputInitCompareLogic: The handle parameter of the board is wrong");
                            break;

                        case -2: Console.Write("\ni_AnalogInputInitCompareLogic: Wrong channel number");
                            break;

                        case -3: Console.Write("\ni_AnalogInputInitCompareLogic: Channel not initialised");
                            break;

                        case -4: Console.Write("\ni_AnalogInputInitCompareLogic: Functionality not available");
                            break;

                        case -5: Console.Write("\ni_AnalogInputInitCompareLogic: Wrong compare level A");
                            break;

                        case -6: Console.Write("\ni_AnalogInputInitCompareLogic: Wrong compare value A");
                            break;

                        case -7: Console.Write("\ni_AnalogInputInitCompareLogic: Wrong compare level B");
                            break;

                        case -8: Console.Write("\ni_AnalogInputInitCompareLogic: Wrong compare value B");
                            break;

                        case -9: Console.Write("\ni_AnalogInputInitCompareLogic: A conversion is already started");
                            break;

                        default: Console.Write("\ni_AnalogInputInitCompareLogic: Error = {0}", i_ReturnValue);
                            break;
                    }
                }
            }

            if (i_ReturnValue == 0)
            {
                i_ReturnValue = PCI3009.i_AnalogInputEnableDisableCompareLogic(PCI3009_NET.cl_PCI3009.PCI3009_ENABLE);

                switch (i_ReturnValue)
                {
                    case 0: Console.Write("\ni_AnalogInputEnableDisableCompareLogic OK");
                        break;

                    case -1: Console.Write("\ni_AnalogInputEnableDisableCompareLogic: The handle parameter of the board is wrong");
                        break;

                    case -2: Console.Write("\ni_AnalogInputEnableDisableCompareLogic: Wrong compare logic flag");
                        break;

                    default: Console.Write("\ni_AnalogInputEnableDisableCompareLogic: Error = {0}", i_ReturnValue);
                        break;
                }
            }

            /* Open the file */
            FileStream fs = new FileStream("sample03.txt", FileMode.Create, FileAccess.ReadWrite, FileShare.Read);
           
            Console.Write("\nEnter the conversion time 10 to 65535 us: ");
            do
            {
                ReadString = Console.ReadLine();
                try
                {
                    w_ConvertTime = Convert.ToUInt16(ReadString);
                }
                catch (Exception) {}
            }
            while (!((w_ConvertTime >= 10) && (w_ConvertTime <= 65535)));

            if (i_ReturnValue == 0)
            {
                w_ChannelMask = 15; /* Channel 0, 1, 2, 3 are to be read */
                i_ReturnValue = PCI3009.i_AnalogInputStartAutoRefresh(w_ChannelMask, PCI3009_NET.cl_PCI3009.PCI3009_MICRO_SECOND, w_ConvertTime);

                switch (i_ReturnValue)
                {
                    case 0: Console.Write("\ni_AnalogInputStartAutoRefresh OK");
                        break;

                    case -1: Console.Write("\ni_AnalogInputStartAutoRefresh: The handle parameter of the board is wrong");
                        break;

                    case -2: Console.Write("\ni_AnalogInputStartAutoRefresh: Wrong channels mask selection");
                        break;

                    case -3: Console.Write("\ni_AnalogInputStartAutoRefresh: Wrong channel 0 mask");
                        break;

                    case -4: Console.Write("\ni_AnalogInputStartAutoRefresh: Channel 0 not initialised");
                        break;

                    default: Console.Write("\ni_AnalogInputStartAutoRefresh: Error = {0}", i_ReturnValue);
                        break;
                }
            }

            if (i_ReturnValue == 0)
            {
                /* Write in the file */
                {
                    Byte[] info = new UTF8Encoding(true).GetBytes("Counter;Channel;Value;Open line;First range;Second range;Third range\n");
                    fs.Write(info, 0, info.Length);
                }

                int cursorLeft = Console.CursorLeft;
                int cursorTop = Console.CursorTop;
                do
                {
                    Console.SetCursorPosition(cursorLeft, cursorTop);
                    for (b_Channel = 0; b_Channel < b_NbrOfChannels; b_Channel++)
                    {
                        if (i_ReturnValue == 0)
                        {
                            i_ReturnValue = PCI3009.i_AnalogInputGetAutoRefreshCompareLogicStates(b_Channel, ref s_AutoRefreshDataPackage);

                            switch (i_ReturnValue)
                            {
                                case 0:
                                    Console.Write("\nCounter = {0} channel {1} = {2}\nopen line: {3}\nFirst range: {4}\nSecond range: {5}\nThird range: {6}",
                                                  s_AutoRefreshDataPackage.dw_ChannelIncrementValue,
                                                  b_Channel,
                                                  s_AutoRefreshDataPackage.d_ChannelValue.ToString("0.0000"),
                                                  s_AutoRefreshDataPackage.b_Open == 0 ? "no" : "yes",
                                                  s_AutoRefreshDataPackage.b_IsInFirstRange == 0 ? "no" : "yes",
                                                  s_AutoRefreshDataPackage.b_IsInSecondRange == 0 ? "no" : "yes",
                                                  s_AutoRefreshDataPackage.b_IsInThirdRange == 0 ? "no" : "yes");

                                    /* Write in the file */
                                    {
                                        Byte[] info = new UTF8Encoding(true).GetBytes(string.Format("{0};{1};{2};{3};{4};{5};{6}\n",
                                                                                      s_AutoRefreshDataPackage.dw_ChannelIncrementValue,
                                                                                      b_Channel,
                                                                                      s_AutoRefreshDataPackage.d_ChannelValue.ToString("0.0000"),
                                                                                      s_AutoRefreshDataPackage.b_Open,
                                                                                      s_AutoRefreshDataPackage.b_IsInFirstRange,
                                                                                      s_AutoRefreshDataPackage.b_IsInSecondRange,
                                                                                      s_AutoRefreshDataPackage.b_IsInThirdRange));
                                        fs.Write(info, 0, info.Length);
                                    }

                                    break;

                                case -1: Console.Write("\ni_AnalogInputGetAutoRefreshCompareLogicStates: The handle parameter of the board is wrong");
                                    break;

                                case -2: Console.Write("\ni_AnalogInputGetAutoRefreshCompareLogicStates: Wrong channel number");
                                    break;

                                case -3: Console.Write("\ni_AnalogInputGetAutoRefreshCompareLogicStates: Channel not initialised");
                                    break;

                                case -4: Console.Write("\ni_AnalogInputGetAutoRefreshCompareLogicStates: Wrong ps_AutoRefreshDataPackage struct size");
                                    break;

                                case -5: Console.Write("\ni_AnalogInputGetAutoRefreshCompareLogicStates: Compare logic not enabled");
                                    break;

                                case -6: Console.Write("\ni_AnalogInputGetAutoRefreshCompareLogicStates: No conversion started");
                                    break;

                                default: Console.Write("\ni_AnalogInputGetAutoRefreshCompareLogicStates: Error = {0}", i_ReturnValue);
                                    break;
                            }
                        }
                    }

                    if ((i_ReturnValue != 0) || (Console.KeyAvailable))
                        b_Stop = 1;

                } while (b_Stop == 0);
            }

            /* Close the file */
            fs.Close();

            if (i_ReturnValue == 0)
            {
                i_ReturnValue = PCI3009.i_AnalogInputStopAutoRefresh();

                switch (i_ReturnValue)
                {
                    case 0: Console.Write("\ni_AnalogInputStopAutoRefresh OK");
                        break;

                    case -1: Console.Write("\ni_AnalogInputStopAutoRefresh: The handle parameter of the board is wrong");
                        break;

                    case -2: Console.Write("\ni_AnalogInputStopAutoRefresh: No conversion started");
                        break;

                    default: Console.Write("\ni_AnalogInputStopAutoRefresh: Error = {0}", i_ReturnValue);
                        break;
                }
            }

            if (i_ReturnValue == 0)
            {
                i_ReturnValue = PCI3009.i_AnalogInputEnableDisableCompareLogic(PCI3009_NET.cl_PCI3009.PCI3009_DISABLE);

                switch (i_ReturnValue)
                {
                    case 0: Console.Write("\ni_AnalogInputEnableDisableCompareLogic OK");
                        break;

                    case -1: Console.Write("\ni_AnalogInputEnableDisableCompareLogic: The handle parameter of the board is wrong");
                        break;

                    case -2: Console.Write("\ni_AnalogInputEnableDisableCompareLogic: Wrong compare logic flag");
                        break;

                    default: Console.Write("\ni_AnalogInputEnableDisableCompareLogic: Error = {0}", i_ReturnValue);
                        break;
                }
            }

            if (b_OpenOk == 1)
            {
                i_ReturnValue = PCI3009.i_CloseBoard();

                switch (i_ReturnValue)
                {
                    case 0: Console.Write("\ni_CloseBoard OK");
                        break;

                    case -1: Console.Write("\ni_CloseBoard: The handle parameter of the board is wrong");
                        break;

                    default: Console.Write("\ni_CloseBoard: Error = {0}", i_ReturnValue);
                        break;
                }
            }

            Console.WriteLine("\nPress any key");
            Console.ReadKey();
        }
    }
}
