using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using PCI3009_NET;

/* Analog output. */

namespace Set1AnalogOutput
{
    class Program
    {
        static void Main(string[] args)
        {
            int i_ReturnValue = 0;
            byte b_OpenOk = 0;
            byte b_Channel = 0;
            int w_AnalogOutputValue = 0;
            String ReadString;
            cl_PCI3009 PCI3009 = new cl_PCI3009();

            Console.Write("\nSet 1 voltage analog output.");
            Console.Write("\nPress any key to start\n");
            Console.ReadKey();

            if (!Utils.Utils.openBoard(PCI3009))
            {
                Console.ReadKey();
                return;
            }

            if (i_ReturnValue == 0)
            {
                Console.Write("\nSelect the analog output channel (0 - 3): ");
                do
                {
                    ReadString = Console.ReadLine();
                    try
                    {
                        b_Channel = Convert.ToByte(ReadString);
                    }
                    catch (Exception) {}
                }
                while (!((b_Channel >= 0) && (b_Channel <= 3)));

                Console.Write("\nSelect the voltage to set: ");
                Console.Write("\n0 for -10V");
                Console.Write("\n2048 for 0V");
                Console.Write("\n4095 for 10V\n");
                do
                {
                    ReadString = Console.ReadLine();
                    try
                    {
                        w_AnalogOutputValue = Convert.ToInt16(ReadString);
                    }
                    catch (Exception) {}
                }
                while (!((w_AnalogOutputValue >= 0) && (w_AnalogOutputValue <= 4095)));

                i_ReturnValue = PCI3009.i_AnalogOutputWrite1Channel(b_Channel, w_AnalogOutputValue);

                switch (i_ReturnValue)
                {
                    case 0: Console.Write("\ni_AnalogOutputWrite1Channel OK");
                        break;

                    case -1: Console.Write("\ni_AnalogOutputWrite1Channel: The handle parameter of the board is wrong");
                        break;

                    case -2: Console.Write("\ni_AnalogOutputWrite1Channel: The channel number parameter is wrong");
                        break;

                    case -3: Console.Write("\ni_AnalogOutputWrite1Channel: The channel value parameter is wrong");
                        break;

                    default: Console.Write("\ni_AnalogOutputWrite1Channel: Error = {0}", i_ReturnValue);
                        break;
                }
            }

            if (b_OpenOk == 1)
            {
                i_ReturnValue = PCI3009.i_CloseBoard();

                switch (i_ReturnValue)
                {
                    case 0: Console.Write("\ni_CloseBoard OK");
                        break;

                    case -1: Console.Write("\ni_CloseBoard: The handle parameter of the board is wrong");
                        break;

                    default: Console.Write("\ni_CloseBoard: Error = {0}", i_ReturnValue);
                        break;
                }
            }

            Console.WriteLine("\nPress any key");
            Console.ReadKey();
        }
    }
}
