using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using PCI3009_NET;

/* Analog output. */

namespace SetMoreAnalogOutputs
{
    class Program
    {
        static void Main(string[] args)
        {
            int i_ReturnValue = 0;
            byte b_OpenOk = 0;
            byte b_Channel = 0;
            byte[] pb_ChannelList = new byte[4];
            int[] pw_AnalogOutputValueList = new int[4];
            String ReadString;
            cl_PCI3009 PCI3009 = new cl_PCI3009();

            Console.Write("\nSet more voltage analog output.");
            Console.Write("\nPress any key to start\n");
            Console.ReadKey();

            if (!Utils.Utils.openBoard(PCI3009))
            {
                Console.ReadKey();
                return;
            }

            if (i_ReturnValue == 0)
            {
                for (b_Channel = 0; b_Channel < 4; b_Channel++)
                {
                    Console.Write("\n\nSelect the voltage to set on channel {0}: ", b_Channel);
                    Console.Write("\n0 for -10V");
                    Console.Write("\n2048 for 0V");
                    Console.Write("\n4095 for 10V\n");
                    do
                    {
                        ReadString = Console.ReadLine();
                        try
                        {
                            pw_AnalogOutputValueList[b_Channel] = Convert.ToInt16(ReadString);
                        }
                        catch (Exception) {}
                    }
                    while (!((pw_AnalogOutputValueList[b_Channel] >= 0) && (pw_AnalogOutputValueList[b_Channel] <= 4095)));

                    pb_ChannelList[b_Channel] = b_Channel;
                }

                i_ReturnValue = PCI3009.i_AnalogOutputWriteMoreChannels(4, pb_ChannelList, pw_AnalogOutputValueList);

                switch (i_ReturnValue)
                {
                    case 0: Console.Write("\ni_AnalogOutputWriteMoreChannels OK");
                        break;

                    case -1: Console.Write("\ni_AnalogOutputWriteMoreChannels: The handle parameter of the board is wrong");
                        break;

                    case -2: Console.Write("\ni_AnalogOutputWriteMoreChannels: Wrong channels number selection");
                        break;

                    case -3: Console.Write("\ni_AnalogOutputWriteMoreChannels: The channel index 0 number parameter is wrong");
                        break;

                    case -4: Console.Write("\ni_AnalogOutputWriteMoreChannels: The channel index 0 value parameter is wrong");
                        break;

                    case -5: Console.Write("\ni_AnalogOutputWriteMoreChannels: The channel index 1 number parameter is wrong");
                        break;

                    case -6: Console.Write("\ni_AnalogOutputWriteMoreChannels: The channel index 1 value parameter is wrong");
                        break;

                    case -7: Console.Write("\ni_AnalogOutputWriteMoreChannels: The channel index 2 number parameter is wrong");
                        break;

                    case -8: Console.Write("\ni_AnalogOutputWriteMoreChannels: The channel index 2 value parameter is wrong");
                        break;

                    case -9: Console.Write("\ni_AnalogOutputWriteMoreChannels: The channel index 3 number parameter is wrong");
                        break;

                    case -10: Console.Write("\ni_AnalogOutputWriteMoreChannels: The channel index 3 value parameter is wrong");
                        break;

                    default: Console.Write("\ni_AnalogOutputWriteMoreChannels: Error = {0}", i_ReturnValue);
                        break;
                }
            }

            if (b_OpenOk == 1)
            {
                i_ReturnValue = PCI3009.i_CloseBoard();

                switch (i_ReturnValue)
                {
                    case 0: Console.Write("\ni_CloseBoard OK");
                        break;

                    case -1: Console.Write("\ni_CloseBoard: The handle parameter of the board is wrong");
                        break;

                    default: Console.Write("\ni_CloseBoard: Error = {0}", i_ReturnValue);
                        break;
                }
            }

            Console.WriteLine("\nPress any key");
            Console.ReadKey();
        }
    }
}
