using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using PCI3009_NET;

namespace ReadAllDigitalInputs
{
    public partial class ReadAllDigitalInputs : Form
    {
        public ReadAllDigitalInputs()
        {
            InitializeComponent();
        }

        private PCI3009_NET.cl_PCI3009 _board;

        private void ReadAllDigitalInputs_Load(object sender, EventArgs e)
        {
            _board = new cl_PCI3009();
            try
            {
                int returnValue = _board.i_OpenBoardViaIndex(0);
                if (returnValue != 0)
                    throw new Exception("i_OpenBoardViaIndex: Error = " + returnValue.ToString());
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                Close();
            }
        }

        private void startButton_Click(object sender, EventArgs e)
        {
            byte status = 0;
            try
            {
                int returnValue = _board.i_DigitalInputReadAll(ref status);
                if (returnValue != 0)
                    throw new Exception("i_DigitalInputReadAll: Error = " + returnValue.ToString());

                digitalInputsValuesLabel.Text = status.ToString();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                Close();
            }
            startButton.Enabled = false;
            stopButton.Enabled = true;
        }

        private void stopButton_Click(object sender, EventArgs e)
        {
            stopButton.Enabled = false;
            startButton.Enabled = true;
        }
    }
}