using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using PCI3009_NET;

namespace Set4DigitalOutputs
{
    public partial class Set4DigitalOutputs : Form
    {
        public Set4DigitalOutputs()
        {
            InitializeComponent();
        }

        private PCI3009_NET.cl_PCI3009 _board;

        private void Set4DigitalOutputs_Load(object sender, EventArgs e)
        {
            stopButton.Enabled = false;
            _board = new cl_PCI3009();
            try
            {
                int returnValue = _board.i_OpenBoardViaIndex(0);
                if (returnValue != 0)
                    throw new Exception("i_OpenBoardViaIndex: Error = " + returnValue.ToString());
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                Close();
            }
        }

        private void startButton_Click(object sender, EventArgs e)
        {       
            byte outputs = 0;
            byte status = 0;
            if (output0CheckBox.Checked)
                outputs += 1;

            if (output1CheckBox.Checked)
                outputs += 2;

            if (output2CheckBox.Checked)
                outputs += 4;

            if (output3CheckBox.Checked)
                outputs += 8;
            try
            {   
                int returnValue = _board.i_DigitalOutputWriteAll(outputs);
                if (returnValue != 0)
                    throw new Exception("i_DigitalOutputWriteAll: Error = " + returnValue.ToString());

                returnValue = _board.i_DigitalOutputReadAll(ref status);
                if (returnValue != 0)
                    throw new Exception("i_DigitalOutputReadAll: Error = " + returnValue.ToString());

                outputValueLabel.Text = status.ToString("X");
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
            startButton.Enabled = false;
            stopButton.Enabled = true;
        }

        private void stopButton_Click(object sender, EventArgs e)
        {
            stopButton.Enabled = false;
            startButton.Enabled = true;
        }
    }
}