using System;
using System.Collections.Generic;
using System.Text;
using PCI3009_NET;

namespace ReadCounter
{
    class Program
    {
        static void Main(string[] args)
        {
            int i_ReturnValue = 0;
            long dw_LatchValue = 0;
            byte b_LatchReg = 0;
            byte b_Stop = 0;
            byte b_OpenOk = 0;
            String ReadString;
            cl_PCI3009 PCI3009 = new cl_PCI3009();

            Console.Write("\n+---------------------------------------------------+");
            Console.Write("\n| APCI-3009 incremental counter SAMPLE05:           |");
            Console.Write("\n| Initialise counter                                |");
            Console.Write("\n| 1*32-Bit counter / simple mode / hysteresis ON    |");
            Console.Write("\n| Read counter                                      |");
            Console.Write("\n+---------------------------------------------------+");
            Console.Write("\n| Press any key for start the sample                |");
            Console.Write("\n+---------------------------------------------------+");
            Console.Write("\n| Press any key to quit                             |");
            Console.Write("\n+---------------------------------------------------+");
            Console.Write("\n");
            Console.ReadKey();

            if (!Utils.Utils.openBoard(PCI3009))
            {
                Console.ReadKey();
                return;
            }

            if (i_ReturnValue == 0)
            {
                i_ReturnValue = PCI3009.i_InitCounter(PCI3009_NET.cl_PCI3009.PCI3009_32BIT_COUNTER,
                                                      PCI3009_NET.cl_PCI3009.PCI3009_SIMPLE_MODE,
                                                      PCI3009_NET.cl_PCI3009.PCI3009_HYSTERESIS_ON,
                                                      PCI3009_NET.cl_PCI3009.PCI3009_SIMPLE_MODE,
                                                      PCI3009_NET.cl_PCI3009.PCI3009_HYSTERESIS_ON);

                switch (i_ReturnValue)
                {
                    case 0: Console.Write("\ni_InitCounter OK");
                        break;

                    case -1: Console.Write("\ni_InitCounter: The handle parameter of the board is wrong");
                        break;

                    case -2: Console.Write("\ni_InitCounter: The module is not a counter module");
                        break;

                    case -3: Console.Write("\ni_InitCounter: The selected counter range is wrong");
                        break;

                    case -4: Console.Write("\ni_InitCounter: The selected first counter operating mode is wrong");
                        break;

                    case -5: Console.Write("\ni_InitCounter: The selected first counter operating option is wrong");
                        break;

                    case -6: Console.Write("\ni_InitCounter: The selected second counter operating mode is wrong");
                        break;

                    case -7: Console.Write("\ni_InitCounter: The selected second counter operating option is wrong");
                        break;

                    default: Console.Write("\ni_InitCounter: Error = {0}", i_ReturnValue);
                        break;
                }
            }

            if (i_ReturnValue == 0)
            {
                Console.Write("\nGet latch register number (0 or 1):");
                do
                {
                    ReadString = Console.ReadLine();
                    try
                    {
                        b_LatchReg = Convert.ToByte(ReadString);
                    }
                    catch (Exception) {}
                }
                while (!((b_LatchReg >= 0) && (b_LatchReg < 2)));
            }

            if (i_ReturnValue == 0)
            {
                while ((i_ReturnValue == 0) && (b_Stop == 0))
                {
                    if (Console.KeyAvailable)
                        b_Stop = 1;

                    i_ReturnValue = PCI3009.i_LatchCounter(b_LatchReg);

                    switch (i_ReturnValue)
                    {
                        case 0: Console.Write("\ni_LatchCounter OK");
                            break;

                        case -1: Console.Write("\ni_LatchCounter: The handle parameter of the board is wrong");
                            break;

                        case -2: Console.Write("\ni_LatchCounter: The module is not a counter module");
                            break;

                        case -3: Console.Write("\ni_LatchCounter: Counter not initialised see function i_InitCounter");
                            break;

                        case -4: Console.Write("\ni_LatchCounter: The selected latch register parameter is wrong");
                            break;

                        default: Console.Write("\ni_LatchCounter: Error = {0}", i_ReturnValue);
                            break;
                    }

                    if (i_ReturnValue == 0)
                    {
                        i_ReturnValue = PCI3009.i_ReadLatchRegisterValue(b_LatchReg, ref dw_LatchValue);

                        switch (i_ReturnValue)
                        {
                            case 0: Console.Write("\nCounter latch register {0} value = {1}", b_LatchReg, dw_LatchValue);
                                break;

                            case -1: Console.Write("\ni_ReadLatchRegisterValue: The handle parameter of the board is wrong");
                                break;

                            case -2: Console.Write("\ni_ReadLatchRegisterValue: The module is not a counter module");
                                break;

                            case -3: Console.Write("\ni_ReadLatchRegisterValue: Counter not initialised see function i_InitCounter");
                                break;

                            case -4: Console.Write("\ni_ReadLatchRegisterValue: The selected latch register parameter is wrong");
                                break;

                            default: Console.Write("\ni_ReadLatchRegisterValue: Error = {0}", i_ReturnValue);
                                break;
                        }
                    }
                }         
            }

            if (b_OpenOk == 1)
            {
                i_ReturnValue = PCI3009.i_CloseBoard();

                switch (i_ReturnValue)
                {
                    case 0: Console.Write("\ni_CloseBoard OK");
                        break;

                    case -1: Console.Write("\ni_CloseBoard: The handle parameter of the board is wrong");
                        break;

                    default: Console.Write("\ni_CloseBoard: Error = {0}", i_ReturnValue);
                        break;
                }
            }

            Console.WriteLine("\nPress any key");
            Console.ReadKey();
        }
    }
}
