using System;
using System.Collections.Generic;
using System.Text;
using PCI3009_NET;

namespace ReadWriteClearCounter
{
    class Program
    {
        static void Main(string[] args)
        {
            int i_ReturnValue = 0;
            long dw_CounterValue = 0;
            byte b_OpenOk = 0;
            String ReadString;
            cl_PCI3009 PCI3009 = new cl_PCI3009();

            Console.Write("\n+---------------------------------------------------+");
            Console.Write("\n| APCI-3009 incremental counter SAMPLE22:           |");
            Console.Write("\n| Initialise counter                                |");
            Console.Write("\n| 1*32-Bit counter / simple mode / hysteresis ON    |");
            Console.Write("\n| Read / wrire / clear counter                      |");
            Console.Write("\n+---------------------------------------------------+");
            Console.Write("\n| Press any key for start the sample                |");
            Console.Write("\n+---------------------------------------------------+");
            Console.Write("\n| Press any key to quit                             |");
            Console.Write("\n+---------------------------------------------------+");
            Console.Write("\n");
            Console.ReadKey();

            if (!Utils.Utils.openBoard(PCI3009))
            {
                Console.ReadKey();
                return;
            }

            if (i_ReturnValue == 0)
            {
                i_ReturnValue = PCI3009.i_InitCounter(PCI3009_NET.cl_PCI3009.PCI3009_32BIT_COUNTER,
                                                      PCI3009_NET.cl_PCI3009.PCI3009_SIMPLE_MODE,
                                                      PCI3009_NET.cl_PCI3009.PCI3009_HYSTERESIS_ON,
                                                      PCI3009_NET.cl_PCI3009.PCI3009_SIMPLE_MODE,
                                                      PCI3009_NET.cl_PCI3009.PCI3009_HYSTERESIS_ON);

                switch (i_ReturnValue)
                {
                    case 0: Console.Write("\ni_InitCounter OK");
                        break;

                    case -1: Console.Write("\ni_InitCounter: The handle parameter of the board is wrong");
                        break;

                    case -2: Console.Write("\ni_InitCounter: The module is not a counter module");
                        break;

                    case -3: Console.Write("\ni_InitCounter: The selected counter range is wrong");
                        break;

                    case -4: Console.Write("\ni_InitCounter: The selected first counter operating mode is wrong");
                        break;

                    case -5: Console.Write("\ni_InitCounter: The selected first counter operating option is wrong");
                        break;

                    case -6: Console.Write("\ni_InitCounter: The selected second counter operating mode is wrong");
                        break;

                    case -7: Console.Write("\ni_InitCounter: The selected second counter operating option is wrong");
                        break;

                    default: Console.Write("\ni_InitCounter: Error = {0}", i_ReturnValue);
                        break;
                }
            }

            if (i_ReturnValue == 0)
            {
                i_ReturnValue = PCI3009.i_ClearCounterValue();

                switch (i_ReturnValue)
                {
                    case 0: Console.Write("\ni_ClearCounterValue OK");
                        break;

                    case -1: Console.Write("\ni_ClearCounterValue: The handle parameter of the board is wrong");
                        break;

                    case -2: Console.Write("\ni_ClearCounterValue: The module is not a counter module");
                        break;

                    case -3: Console.Write("\ni_ClearCounterValue: Counter not initialised see function i_InitCounter");
                        break;

                    default: Console.Write("\ni_ClearCounterValue: Error = {0}", i_ReturnValue);
                        break;
                }
            }

            if (i_ReturnValue == 0)
            {
                i_ReturnValue = PCI3009.i_Read32BitCounterValue(ref dw_CounterValue);

                switch (i_ReturnValue)
                {
                    case 0: Console.Write("\nCounter value = {0}", dw_CounterValue);
                        break;

                    case -1: Console.Write("\ni_Read32BitCounterValue: The handle parameter of the board is wrong");
                        break;

                    case -2: Console.Write("\ni_Read32BitCounterValue: The module is not a counter module");
                        break;

                    case -3: Console.Write("\ni_Read32BitCounterValue: Counter not initialised see function i_InitCounter");
                        break;

                    default: Console.Write("\ni_Read32BitCounterValue: Error = {0}", i_ReturnValue);
                        break;
                }
            }

            if (i_ReturnValue == 0)
            {
                Console.Write("\nGet the counter value to write (0 - 4294967295):");
                do
                {
                    ReadString = Console.ReadLine();
                    try
                    {
                        dw_CounterValue = Convert.ToInt32(ReadString);
                    }
                    catch (Exception) {}
                }
                while (!((dw_CounterValue >= 0) && (dw_CounterValue < 4294967295)));

                i_ReturnValue = PCI3009.i_Write32BitCounterValue(dw_CounterValue);

                switch (i_ReturnValue)
                {
                    case 0: Console.Write("\ni_Write32BitCounterValue OK");
                        break;

                    case -1: Console.Write("\ni_Write32BitCounterValue: The handle parameter of the board is wrong");
                        break;

                    case -2: Console.Write("\ni_Write32BitCounterValue: The module is not a counter module");
                        break;

                    case -3: Console.Write("\ni_Write32BitCounterValue: Counter not initialised see function i_InitCounter");
                        break;

                    default: Console.Write("\ni_Write32BitCounterValue: Error = {0}", i_ReturnValue);
                        break;
                }
            }

            if (i_ReturnValue == 0)
            {
                i_ReturnValue = PCI3009.i_Read32BitCounterValue(ref dw_CounterValue);

                switch (i_ReturnValue)
                {
                    case 0: Console.Write("\nCounter value = {0}", dw_CounterValue);
                        break;

                    case -1: Console.Write("\ni_Read32BitCounterValue: The handle parameter of the board is wrong");
                        break;

                    case -2: Console.Write("\ni_Read32BitCounterValue: The module is not a counter module");
                        break;

                    case -3: Console.Write("\ni_Read32BitCounterValue: Counter not initialised see function i_InitCounter");
                        break;

                    default: Console.Write("\ni_Read32BitCounterValue: Error = {0}", i_ReturnValue);
                        break;
                }
            }

            if (b_OpenOk == 1)
            {
                i_ReturnValue = PCI3009.i_CloseBoard();

                switch (i_ReturnValue)
                {
                    case 0: Console.Write("\ni_CloseBoard OK");
                        break;

                    case -1: Console.Write("\ni_CloseBoard: The handle parameter of the board is wrong");
                        break;

                    default: Console.Write("\ni_CloseBoard: Error = {0}", i_ReturnValue);
                        break;
                }
            }

            Console.WriteLine("\nPress any key");
            Console.ReadKey();
        }
    }
}
